let DEBUG = true;
let postMessageKey = "";

function yRegisterPlugin(in_DEBUG, inPostMessageKey) {
    DEBUG = (in_DEBUG === "1");
    postMessageKey = inPostMessageKey;
}

function yRunFlutter(page, method, params = {}) {
    window.postMessage(`${postMessageKey}_${JSON.stringify({"page": page, "method": method, "params": params})}`, "*");
}

//function yConfigIP(ip) {
//    ySave("YFree_YConfig_IP", ip);
//}
//
//function yCloseInput() {
//    document.activeElement.blur();
//}
//
//function ySave(key, value) {
//    localStorage.setItem(key, value);
//}
//
//function ySaveObj(key, obj) {
//    localStorage.setItem(key, yToJson(obj));
//}
//
//function yRead(key) {
//    return localStorage.getItem(key);
//}
//
//function yReadObj(key) {
//    return yFromJson(localStorage.getItem(key));
//}
//
//function yDelete(key) {
//    localStorage.removeItem(key);
//}
//
//function yIntent(page, params = null, type = 1) {
//    switch (type) {
//        case 0: //替换
//            location.replace(page);
//            break;
//        case 1: //前进
//            location.href = page;
//            break;
//        case 2: //新窗口
//            window.open(page);
//            break;
//    }
//}
//
//function yRefresh() {
//    location.reload(true);
//}
//
//function yFinish() {
//    history.back();
//}
//
//function yRunOnDelay(delay, action) {
//    return setTimeout(action, delay);
//}
//
//function yRunOnLoop(loopTime, action, firstDelay = false) {
//    if (!firstDelay) action();
//    return setInterval(action, loopTime);
//}
//
//function yStopRun(task) {
//    clearTimeout(task);
//    clearInterval(task);
//}
//
//function yIsEmpty(obj) {
//    return obj == null || obj.toString() === "";
//}
//
//function yIsNotEmpty(obj) {
//    return obj != null && obj.toString() !== "";
//}
//
//function yLog(msg) {
//    if (DEBUG) console.log(msg.toString());
//}
//
//function yToJson(obj) {
//    return JSON.stringify(obj);
//}
//
//function yFromJson(json) {
//    return yIsEmpty(json) ? null : JSON.parse(json);
//}
//
//function yRandomNum(minNum, maxNum) {
//    switch (arguments.length) {
//        case 1:
//            return parseInt(Math.random() * minNum + 1, 10);
//        case 2:
//            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
//        default:
//            return 0;
//    }
//}
//
//function yAesEncrypt(content, password) {
//    return String(CryptoJS.AES.encrypt(content, CryptoJS.SHA256(password), {
//        iv: CryptoJS.enc.Hex.parse("0000000000000000"),
//        mode: CryptoJS.mode.CBC,
//        padding: CryptoJS.pad.Pkcs7
//    }));
//}
//
//function yAesDecrypt(content, password) {
//    return CryptoJS.AES.decrypt(content.toString(), CryptoJS.SHA256(password), {
//        iv: CryptoJS.enc.Hex.parse("0000000000000000"),
//        mode: CryptoJS.mode.CBC,
//        padding: CryptoJS.pad.Pkcs7
//    }).toString(CryptoJS.enc.Utf8);
//}
//
///* String */
//String.prototype.contains = function (text) {
//    return this.indexOf(text) >= 0;
//};
//
///* Array */
//Array.prototype.indexOf = function (val) {
//    for (var i = 0; i < this.length; i++) {
//        if (this[i] == val) return i;
//    }
//    return -1;
//};
//
//Array.prototype.remove = function (val) {
//    var index = this.indexOf(val);
//    if (index > -1) {
//        this.splice(index, 1);
//    }
//};
//
//Array.prototype.contains = function (val) {
//    return this.indexOf(val) > -1;
//};
//
///* Date Format */
//Date.prototype.format = function (fmt) { //author: meizz
//    let o = {
//        "M+": this.getMonth() + 1,                 //月份
//        "d+": this.getDate(),                    //日
//        "h+": this.getHours(),                   //小时
//        "m+": this.getMinutes(),                 //分
//        "s+": this.getSeconds(),                 //秒
//        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
//        "S": this.getMilliseconds()             //毫秒
//    };
//    if (/(y+)/.test(fmt))
//        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
//    for (let k in o)
//        if (new RegExp("(" + k + ")").test(fmt))
//            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
//    return fmt;
//}
//
///* Base64 */
//function base64_encode(str) { // 编码，配合encodeURIComponent使用
//    var c1, c2, c3;
//    var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
//    var i = 0, len = str.length, strin = '';
//    while (i < len) {
//        c1 = str.charCodeAt(i++) & 0xff;
//        if (i == len) {
//            strin += base64EncodeChars.charAt(c1 >> 2);
//            strin += base64EncodeChars.charAt((c1 & 0x3) << 4);
//            strin += "==";
//            break;
//        }
//        c2 = str.charCodeAt(i++);
//        if (i == len) {
//            strin += base64EncodeChars.charAt(c1 >> 2);
//            strin += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
//            strin += base64EncodeChars.charAt((c2 & 0xF) << 2);
//            strin += "=";
//            break;
//        }
//        c3 = str.charCodeAt(i++);
//        strin += base64EncodeChars.charAt(c1 >> 2);
//        strin += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
//        strin += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));
//        strin += base64EncodeChars.charAt(c3 & 0x3F)
//    }
//    return strin
//}
//
//function base64_decode(input) { // 解码，配合decodeURIComponent使用
//    var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
//    var output = "";
//    var chr1, chr2, chr3;
//    var enc1, enc2, enc3, enc4;
//    var i = 0;
//    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
//    while (i < input.length) {
//        enc1 = base64EncodeChars.indexOf(input.charAt(i++));
//        enc2 = base64EncodeChars.indexOf(input.charAt(i++));
//        enc3 = base64EncodeChars.indexOf(input.charAt(i++));
//        enc4 = base64EncodeChars.indexOf(input.charAt(i++));
//        chr1 = (enc1 << 2) | (enc2 >> 4);
//        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
//        chr3 = ((enc3 & 3) << 6) | enc4;
//        output = output + String.fromCharCode(chr1);
//        if (enc3 != 64) {
//            output = output + String.fromCharCode(chr2);
//        }
//        if (enc4 != 64) {
//            output = output + String.fromCharCode(chr3);
//        }
//    }
//    return utf8_decode(output);
//}
//
//function utf8_decode(utftext) { // utf-8解码
//    var string = '';
//    let i = 0;
//    let c = 0;
//    let c1 = 0;
//    let c2 = 0;
//    while (i < utftext.length) {
//        c = utftext.charCodeAt(i);
//        if (c < 128) {
//            string += String.fromCharCode(c);
//            i++;
//        } else if ((c > 191) && (c < 224)) {
//            c1 = utftext.charCodeAt(i + 1);
//            string += String.fromCharCode(((c & 31) << 6) | (c1 & 63));
//            i += 2;
//        } else {
//            c1 = utftext.charCodeAt(i + 1);
//            c2 = utftext.charCodeAt(i + 2);
//            string += String.fromCharCode(((c & 15) << 12) | ((c1 & 63) << 6) | (c2 & 63));
//            i += 3;
//        }
//    }
//    return string;
//}
//
///* cry */
//(function(a,b){if(typeof exports==="object"){module.exports=exports=b()}else{if(typeof define==="function"&&define.amd){define([],b)}else{a.CryptoJS=b()}}}(this,function(){var a=a||(function(j,l){var o=Object.create||(function(){function p(){}return function(r){var q;p.prototype=r;q=new p();p.prototype=null;return q}}());var d={};var f=d.lib={};var b=f.Base=(function(){return{extend:function(q){var p=o(this);if(q){p.mixIn(q)}if(!p.hasOwnProperty("init")||this.init===p.init){p.init=function(){p.$super.init.apply(this,arguments)}}p.init.prototype=p;p.$super=this;return p},create:function(){var p=this.extend();p.init.apply(p,arguments);return p},init:function(){},mixIn:function(q){for(var p in q){if(q.hasOwnProperty(p)){this[p]=q[p]}}if(q.hasOwnProperty("toString")){this.toString=q.toString}},clone:function(){return this.init.prototype.extend(this)}}}());var e=f.WordArray=b.extend({init:function(q,p){q=this.words=q||[];if(p!=l){this.sigBytes=p}else{this.sigBytes=q.length*4}},toString:function(p){return(p||m).stringify(this)},concat:function(v){var s=this.words;var r=v.words;var p=this.sigBytes;var u=v.sigBytes;this.clamp();if(p%4){for(var t=0;t<u;t++){var q=(r[t>>>2]>>>(24-(t%4)*8))&255;s[(p+t)>>>2]|=q<<(24-((p+t)%4)*8)}}else{for(var t=0;t<u;t+=4){s[(p+t)>>>2]=r[t>>>2]}}this.sigBytes+=u;return this},clamp:function(){var q=this.words;var p=this.sigBytes;q[p>>>2]&=4294967295<<(32-(p%4)*8);q.length=j.ceil(p/4)},clone:function(){var p=b.clone.call(this);p.words=this.words.slice(0);return p},random:function(u){var t=[];var r=(function(x){var x=x;var w=987654321;var v=4294967295;return function(){w=(36969*(w&65535)+(w>>16))&v;x=(18000*(x&65535)+(x>>16))&v;var y=((w<<16)+x)&v;y/=4294967296;y+=0.5;return y*(j.random()>0.5?1:-1)}});for(var q=0,p;q<u;q+=4){var s=r((p||j.random())*4294967296);p=s()*987654071;t.push((s()*4294967296)|0)}return new e.init(t,u)}});var i=d.enc={};var m=i.Hex={stringify:function(r){var t=r.words;var q=r.sigBytes;var s=[];for(var p=0;p<q;p++){var u=(t[p>>>2]>>>(24-(p%4)*8))&255;s.push((u>>>4).toString(16));s.push((u&15).toString(16))}return s.join("")},parse:function(r){var p=r.length;var s=[];for(var q=0;q<p;q+=2){s[q>>>3]|=parseInt(r.substr(q,2),16)<<(24-(q%8)*4)}return new e.init(s,p/2)}};var h=i.Latin1={stringify:function(s){var t=s.words;var r=s.sigBytes;var p=[];for(var q=0;q<r;q++){var u=(t[q>>>2]>>>(24-(q%4)*8))&255;p.push(String.fromCharCode(u))}return p.join("")},parse:function(r){var p=r.length;var s=[];for(var q=0;q<p;q++){s[q>>>2]|=(r.charCodeAt(q)&255)<<(24-(q%4)*8)}return new e.init(s,p)}};var g=i.Utf8={stringify:function(p){try{return decodeURIComponent(escape(h.stringify(p)))}catch(q){throw new Error("Malformed UTF-8 data")}},parse:function(p){return h.parse(unescape(encodeURIComponent(p)))}};var n=f.BufferedBlockAlgorithm=b.extend({reset:function(){this._data=new e.init();this._nDataBytes=0},_append:function(p){if(typeof p=="string"){p=g.parse(p)}this._data.concat(p);this._nDataBytes+=p.sigBytes},_process:function(v){var p=this._data;var w=p.words;var x=p.sigBytes;var s=this.blockSize;var u=s*4;var t=x/u;if(v){t=j.ceil(t)}else{t=j.max((t|0)-this._minBufferSize,0)}var r=t*s;var q=j.min(r*4,x);if(r){for(var z=0;z<r;z+=s){this._doProcessBlock(w,z)}var y=w.splice(0,r);p.sigBytes-=q}return new e.init(y,q)},clone:function(){var p=b.clone.call(this);p._data=this._data.clone();return p},_minBufferSize:0});var k=f.Hasher=n.extend({cfg:b.extend(),init:function(p){this.cfg=this.cfg.extend(p);this.reset()},reset:function(){n.reset.call(this);this._doReset()},update:function(p){this._append(p);this._process();return this},finalize:function(p){if(p){this._append(p)}var q=this._doFinalize();return q},blockSize:512/32,_createHelper:function(p){return function(r,q){return new p.init(q).finalize(r)}},_createHmacHelper:function(p){return function(r,q){return new c.HMAC.init(p,q).finalize(r)}}});var c=d.algo={};return d}(Math));(function(){var g=a;var c=g.lib;var b=c.WordArray;var f=g.enc;var e=f.Base64={stringify:function(j){var l=j.words;var n=j.sigBytes;var q=this._map;j.clamp();var k=[];for(var s=0;s<n;s+=3){var o=(l[s>>>2]>>>(24-(s%4)*8))&255;var h=(l[(s+1)>>>2]>>>(24-((s+1)%4)*8))&255;var m=(l[(s+2)>>>2]>>>(24-((s+2)%4)*8))&255;var i=(o<<16)|(h<<8)|m;for(var r=0;(r<4)&&(s+r*0.75<n);r++){k.push(q.charAt((i>>>(6*(3-r)))&63))}}var p=q.charAt(64);if(p){while(k.length%4){k.push(p)}}return k.join("")},parse:function(l){var k=l.length;var m=this._map;var j=this._reverseMap;if(!j){j=this._reverseMap=[];for(var h=0;h<m.length;h++){j[m.charCodeAt(h)]=h}}var i=m.charAt(64);if(i){var n=l.indexOf(i);if(n!==-1){k=n}}return d(l,k,j)},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="};function d(l,n,m){var h=[];var o=0;for(var k=0;k<n;k++){if(k%4){var j=m[l.charCodeAt(k-1)]<<((k%4)*2);var i=m[l.charCodeAt(k)]>>>(6-(k%4)*2);h[o>>>2]|=(j|i)<<(24-(o%4)*8);o++}}return b.create(h,o)}}());(function(j){var h=a;var i=h.lib;var d=i.WordArray;var l=i.Hasher;var e=h.algo;var m=[];(function(){for(var n=0;
//                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           n<64;n++){m[n]=(j.abs(j.sin(n+1))*4294967296)|0}}());var f=e.MD5=l.extend({_doReset:function(){this._hash=new d.init([1732584193,4023233417,2562383102,271733878])},_doProcessBlock:function(v,O){for(var F=0;F<16;F++){var N=O+F;var n=v[N];v[N]=((((n<<8)|(n>>>24))&16711935)|(((n<<24)|(n>>>8))&4278255360))}var E=this._hash.words;var q=v[O+0];var o=v[O+1];var G=v[O+2];var C=v[O+3];var B=v[O+4];var z=v[O+5];var x=v[O+6];var t=v[O+7];var r=v[O+8];var p=v[O+9];var D=v[O+10];var A=v[O+11];var y=v[O+12];var w=v[O+13];var u=v[O+14];var s=v[O+15];var L=E[0];var K=E[1];var J=E[2];var I=E[3];L=c(L,K,J,I,q,7,m[0]);I=c(I,L,K,J,o,12,m[1]);J=c(J,I,L,K,G,17,m[2]);K=c(K,J,I,L,C,22,m[3]);L=c(L,K,J,I,B,7,m[4]);I=c(I,L,K,J,z,12,m[5]);J=c(J,I,L,K,x,17,m[6]);K=c(K,J,I,L,t,22,m[7]);L=c(L,K,J,I,r,7,m[8]);I=c(I,L,K,J,p,12,m[9]);J=c(J,I,L,K,D,17,m[10]);K=c(K,J,I,L,A,22,m[11]);L=c(L,K,J,I,y,7,m[12]);I=c(I,L,K,J,w,12,m[13]);J=c(J,I,L,K,u,17,m[14]);K=c(K,J,I,L,s,22,m[15]);L=k(L,K,J,I,o,5,m[16]);I=k(I,L,K,J,x,9,m[17]);J=k(J,I,L,K,A,14,m[18]);K=k(K,J,I,L,q,20,m[19]);L=k(L,K,J,I,z,5,m[20]);I=k(I,L,K,J,D,9,m[21]);J=k(J,I,L,K,s,14,m[22]);K=k(K,J,I,L,B,20,m[23]);L=k(L,K,J,I,p,5,m[24]);I=k(I,L,K,J,u,9,m[25]);J=k(J,I,L,K,C,14,m[26]);K=k(K,J,I,L,r,20,m[27]);L=k(L,K,J,I,w,5,m[28]);I=k(I,L,K,J,G,9,m[29]);J=k(J,I,L,K,t,14,m[30]);K=k(K,J,I,L,y,20,m[31]);L=g(L,K,J,I,z,4,m[32]);I=g(I,L,K,J,r,11,m[33]);J=g(J,I,L,K,A,16,m[34]);K=g(K,J,I,L,u,23,m[35]);L=g(L,K,J,I,o,4,m[36]);I=g(I,L,K,J,B,11,m[37]);J=g(J,I,L,K,t,16,m[38]);K=g(K,J,I,L,D,23,m[39]);L=g(L,K,J,I,w,4,m[40]);I=g(I,L,K,J,q,11,m[41]);J=g(J,I,L,K,C,16,m[42]);K=g(K,J,I,L,x,23,m[43]);L=g(L,K,J,I,p,4,m[44]);I=g(I,L,K,J,y,11,m[45]);J=g(J,I,L,K,s,16,m[46]);K=g(K,J,I,L,G,23,m[47]);L=b(L,K,J,I,q,6,m[48]);I=b(I,L,K,J,t,10,m[49]);J=b(J,I,L,K,u,15,m[50]);K=b(K,J,I,L,z,21,m[51]);L=b(L,K,J,I,y,6,m[52]);I=b(I,L,K,J,C,10,m[53]);J=b(J,I,L,K,D,15,m[54]);K=b(K,J,I,L,o,21,m[55]);L=b(L,K,J,I,r,6,m[56]);I=b(I,L,K,J,s,10,m[57]);J=b(J,I,L,K,x,15,m[58]);K=b(K,J,I,L,w,21,m[59]);L=b(L,K,J,I,B,6,m[60]);I=b(I,L,K,J,A,10,m[61]);J=b(J,I,L,K,G,15,m[62]);K=b(K,J,I,L,p,21,m[63]);E[0]=(E[0]+L)|0;E[1]=(E[1]+K)|0;E[2]=(E[2]+J)|0;E[3]=(E[3]+I)|0},_doFinalize:function(){var w=this._data;var r=w.words;var o=this._nDataBytes*8;var p=w.sigBytes*8;r[p>>>5]|=128<<(24-p%32);var n=j.floor(o/4294967296);var t=o;r[(((p+64)>>>9)<<4)+15]=((((n<<8)|(n>>>24))&16711935)|(((n<<24)|(n>>>8))&4278255360));r[(((p+64)>>>9)<<4)+14]=((((t<<8)|(t>>>24))&16711935)|(((t<<24)|(t>>>8))&4278255360));w.sigBytes=(r.length+1)*4;this._process();var v=this._hash;var q=v.words;for(var u=0;u<4;u++){var s=q[u];q[u]=(((s<<8)|(s>>>24))&16711935)|(((s<<24)|(s>>>8))&4278255360)}return v},clone:function(){var n=l.clone.call(this);n._hash=this._hash.clone();return n}});function c(q,p,n,t,o,s,r){var u=q+((p&n)|(~p&t))+o+r;return((u<<s)|(u>>>(32-s)))+p}function k(q,p,n,t,o,s,r){var u=q+((p&t)|(n&~t))+o+r;return((u<<s)|(u>>>(32-s)))+p}function g(q,p,n,t,o,s,r){var u=q+(p^n^t)+o+r;return((u<<s)|(u>>>(32-s)))+p}function b(q,p,n,t,o,s,r){var u=q+(n^(p|~t))+o+r;return((u<<s)|(u>>>(32-s)))+p}h.MD5=l._createHelper(f);h.HmacMD5=l._createHmacHelper(f)}(Math));(function(){var g=a;var d=g.lib;var f=d.WordArray;var h=d.Hasher;var e=g.algo;var c=[];var b=e.SHA1=h.extend({_doReset:function(){this._hash=new f.init([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(k,s){var p=this._hash.words;var o=p[0];var n=p[1];var m=p[2];var l=p[3];var j=p[4];for(var i=0;i<80;i++){if(i<16){c[i]=k[s+i]|0}else{var r=c[i-3]^c[i-8]^c[i-14]^c[i-16];c[i]=(r<<1)|(r>>>31)}var q=((o<<5)|(o>>>27))+j+c[i];if(i<20){q+=((n&m)|(~n&l))+1518500249}else{if(i<40){q+=(n^m^l)+1859775393}else{if(i<60){q+=((n&m)|(n&l)|(m&l))-1894007588}else{q+=(n^m^l)-899497514}}}j=l;l=m;m=(n<<30)|(n>>>2);n=o;o=q}p[0]=(p[0]+o)|0;p[1]=(p[1]+n)|0;p[2]=(p[2]+m)|0;p[3]=(p[3]+l)|0;p[4]=(p[4]+j)|0},_doFinalize:function(){var k=this._data;var l=k.words;var i=this._nDataBytes*8;var j=k.sigBytes*8;l[j>>>5]|=128<<(24-j%32);l[(((j+64)>>>9)<<4)+14]=Math.floor(i/4294967296);l[(((j+64)>>>9)<<4)+15]=i;k.sigBytes=l.length*4;this._process();return this._hash},clone:function(){var i=h.clone.call(this);i._hash=this._hash.clone();return i}});g.SHA1=h._createHelper(b);g.HmacSHA1=h._createHmacHelper(b)}());(function(b){var j=a;var k=j.lib;var f=k.WordArray;var d=k.Hasher;var g=j.algo;var i=[];var h=[];(function(){function l(r){var q=b.sqrt(r);for(var p=2;p<=q;p++){if(!(r%p)){return false}}return true}function o(p){return((p-(p|0))*4294967296)|0}var m=2;var n=0;while(n<64){if(l(m)){if(n<8){i[n]=o(b.pow(m,1/2))}h[n]=o(b.pow(m,1/3));n++}m++}}());var c=[];var e=g.SHA256=d.extend({_doReset:function(){this._hash=new f.init(i.slice(0))},_doProcessBlock:function(o,n){var t=this._hash.words;var y=t[0];var v=t[1];var u=t[2];var r=t[3];var p=t[4];var G=t[5];var F=t[6];var E=t[7];for(var D=0;D<64;D++){if(D<16){c[D]=o[n+D]|0}else{var m=c[D-15];var B=((m<<25)|(m>>>7))^((m<<14)|(m>>>18))^(m>>>3);var w=c[D-2];var z=((w<<15)|(w>>>17))^((w<<13)|(w>>>19))^(w>>>10);
//        c[D]=B+c[D-7]+z+c[D-16]}var x=(p&G)^(~p&F);var l=(y&v)^(y&u)^(v&u);var C=((y<<30)|(y>>>2))^((y<<19)|(y>>>13))^((y<<10)|(y>>>22));var A=((p<<26)|(p>>>6))^((p<<21)|(p>>>11))^((p<<7)|(p>>>25));var s=E+A+x+h[D]+c[D];var q=C+l;E=F;F=G;G=p;p=(r+s)|0;r=u;u=v;v=y;y=(s+q)|0}t[0]=(t[0]+y)|0;t[1]=(t[1]+v)|0;t[2]=(t[2]+u)|0;t[3]=(t[3]+r)|0;t[4]=(t[4]+p)|0;t[5]=(t[5]+G)|0;t[6]=(t[6]+F)|0;t[7]=(t[7]+E)|0},_doFinalize:function(){var l=this._data;var m=l.words;var n=this._nDataBytes*8;var o=l.sigBytes*8;m[o>>>5]|=128<<(24-o%32);m[(((o+64)>>>9)<<4)+14]=b.floor(n/4294967296);m[(((o+64)>>>9)<<4)+15]=n;l.sigBytes=m.length*4;this._process();return this._hash},clone:function(){var l=d.clone.call(this);l._hash=this._hash.clone();return l}});j.SHA256=d._createHelper(e);j.HmacSHA256=d._createHmacHelper(e)}(Math));(function(){var g=a;var c=g.lib;var d=c.WordArray;var f=g.enc;var e=f.Utf16=f.Utf16BE={stringify:function(l){var k=l.words;var j=l.sigBytes;var m=[];for(var i=0;i<j;i+=2){var h=(k[i>>>2]>>>(16-(i%4)*8))&65535;m.push(String.fromCharCode(h))}return m.join("")},parse:function(h){var j=h.length;var k=[];for(var i=0;i<j;i++){k[i>>>1]|=h.charCodeAt(i)<<(16-(i%2)*16)}return d.create(k,j*2)}};f.Utf16LE={stringify:function(l){var k=l.words;var j=l.sigBytes;var m=[];for(var i=0;i<j;i+=2){var h=b((k[i>>>2]>>>(16-(i%4)*8))&65535);m.push(String.fromCharCode(h))}return m.join("")},parse:function(h){var j=h.length;var k=[];for(var i=0;i<j;i++){k[i>>>1]|=b(h.charCodeAt(i)<<(16-(i%2)*16))}return d.create(k,j*2)}};function b(h){return((h<<8)&4278255360)|((h>>>8)&16711935)}}());(function(){if(typeof ArrayBuffer!="function"){return}var f=a;var d=f.lib;var e=d.WordArray;var c=e.init;var b=e.init=function(i){if(i instanceof ArrayBuffer){i=new Uint8Array(i)}if(i instanceof Int8Array||(typeof Uint8ClampedArray!=="undefined"&&i instanceof Uint8ClampedArray)||i instanceof Int16Array||i instanceof Uint16Array||i instanceof Int32Array||i instanceof Uint32Array||i instanceof Float32Array||i instanceof Float64Array){i=new Uint8Array(i.buffer,i.byteOffset,i.byteLength)}if(i instanceof Uint8Array){var g=i.byteLength;var j=[];for(var h=0;h<g;h++){j[h>>>2]|=i[h]<<(24-(h%4)*8)}c.call(this,j,g)}else{c.apply(this,arguments)}};b.prototype=e}());(function(k){var p=a;var t=p.lib;var l=t.WordArray;var e=t.Hasher;var b=p.algo;var n=l.create([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,7,4,13,1,10,6,15,3,12,0,9,5,2,14,11,8,3,10,14,4,9,15,8,1,2,7,0,6,13,11,5,12,1,9,11,10,0,8,12,4,13,3,7,15,14,5,6,2,4,0,5,9,7,12,2,10,14,1,3,8,11,6,15,13]);var h=l.create([5,14,7,0,9,2,11,4,13,6,15,8,1,10,3,12,6,11,3,7,0,13,5,10,14,15,8,12,4,9,1,2,15,5,1,3,7,14,6,9,11,8,12,2,10,0,4,13,8,6,4,1,3,11,15,0,5,12,2,13,9,7,10,14,12,15,10,4,1,5,8,7,6,2,13,14,0,3,9,11]);var i=l.create([11,14,15,12,5,8,7,9,11,13,14,15,6,7,9,8,7,6,8,13,11,9,7,15,7,12,15,9,11,7,13,12,11,13,6,7,14,9,13,15,14,8,13,6,5,12,7,5,11,12,14,15,14,15,9,8,9,14,5,6,8,6,5,12,9,15,5,11,6,8,13,12,5,12,13,14,11,8,5,6]);var g=l.create([8,9,9,11,13,15,15,5,7,7,8,11,14,14,12,6,9,13,15,7,12,8,9,11,7,7,12,7,6,15,13,11,9,7,15,11,8,6,6,14,12,13,5,14,13,13,7,5,15,5,8,11,14,14,6,14,6,9,12,9,12,5,15,8,8,5,12,9,12,5,14,6,8,13,6,5,15,13,11,11]);var d=l.create([0,1518500249,1859775393,2400959708,2840853838]);var m=l.create([1352829926,1548603684,1836072691,2053994217,0]);var c=b.RIPEMD160=e.extend({_doReset:function(){this._hash=l.create([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(x,v){for(var N=0;N<16;N++){var D=v+N;var w=x[D];x[D]=((((w<<8)|(w>>>24))&16711935)|(((w<<24)|(w>>>8))&4278255360))}var A=this._hash.words;var G=d.words;var R=m.words;var I=n.words;var E=h.words;var O=i.words;var K=g.words;var J,z,y,L,B;var F,P,u,H,Q;F=J=A[0];P=z=A[1];u=y=A[2];H=L=A[3];Q=B=A[4];var C;for(var N=0;N<80;N+=1){C=(J+x[v+I[N]])|0;if(N<16){C+=j(z,y,L)+G[0]}else{if(N<32){C+=f(z,y,L)+G[1]}else{if(N<48){C+=s(z,y,L)+G[2]}else{if(N<64){C+=r(z,y,L)+G[3]}else{C+=q(z,y,L)+G[4]}}}}C=C|0;C=o(C,O[N]);C=(C+B)|0;J=B;B=L;L=o(y,10);y=z;z=C;C=(F+x[v+E[N]])|0;if(N<16){C+=q(P,u,H)+R[0]}else{if(N<32){C+=r(P,u,H)+R[1]}else{if(N<48){C+=s(P,u,H)+R[2]}else{if(N<64){C+=f(P,u,H)+R[3]}else{C+=j(P,u,H)+R[4]}}}}C=C|0;C=o(C,K[N]);C=(C+Q)|0;F=Q;Q=H;H=o(u,10);u=P;P=C}C=(A[1]+y+H)|0;A[1]=(A[2]+L+Q)|0;A[2]=(A[3]+B+F)|0;A[3]=(A[4]+J+P)|0;A[4]=(A[0]+z+u)|0;A[0]=C},_doFinalize:function(){var w=this._data;var u=w.words;var x=this._nDataBytes*8;var v=w.sigBytes*8;u[v>>>5]|=128<<(24-v%32);u[(((v+64)>>>9)<<4)+14]=((((x<<8)|(x>>>24))&16711935)|(((x<<24)|(x>>>8))&4278255360));w.sigBytes=(u.length+1)*4;this._process();var A=this._hash;var z=A.words;for(var y=0;y<5;y++){var B=z[y];z[y]=(((B<<8)|(B>>>24))&16711935)|(((B<<24)|(B>>>8))&4278255360)}return A},clone:function(){var u=e.clone.call(this);u._hash=this._hash.clone();return u}});function j(u,w,v){return((u)^(w)^(v))}function f(u,w,v){return(((u)&(w))|((~u)&(v)))}function s(u,w,v){return(((u)|(~(w)))^(v))}function r(u,w,v){return(((u)&(v))|((w)&(~(v))))}function q(u,w,v){return((u)^((w)|(~(v))))}function o(u,v){return(u<<v)|(u>>>(32-v))
//}p.RIPEMD160=e._createHelper(c);p.HmacRIPEMD160=e._createHmacHelper(c)}(Math));(function(){var g=a;var d=g.lib;var b=d.Base;var f=g.enc;var h=f.Utf8;var e=g.algo;var c=e.HMAC=b.extend({init:function(n,k){n=this._hasher=new n.init();if(typeof k=="string"){k=h.parse(k)}var q=n.blockSize;var o=q*4;if(k.sigBytes>o){k=n.finalize(k)}k.clamp();var m=this._oKey=k.clone();var j=this._iKey=k.clone();var l=m.words;var p=j.words;for(var i=0;i<q;i++){l[i]^=1549556828;p[i]^=909522486}m.sigBytes=j.sigBytes=o;this.reset()},reset:function(){var i=this._hasher;i.reset();i.update(this._iKey)},update:function(i){this._hasher.update(i);return this},finalize:function(i){var j=this._hasher;var l=j.finalize(i);j.reset();var k=j.finalize(this._oKey.clone().concat(l));return k}})}());(function(){var f=a;var i=f.lib;var g=i.Base;var d=i.WordArray;var b=f.algo;var h=b.SHA1;var c=b.HMAC;var e=b.PBKDF2=g.extend({cfg:g.extend({keySize:128/32,hasher:h,iterations:1}),init:function(j){this.cfg=this.cfg.extend(j)},compute:function(j,t){var w=this.cfg;var u=c.create(w.hasher,j);var v=d.create();var o=d.create([1]);var y=v.words;var m=o.words;var x=w.keySize;var l=w.iterations;while(y.length<x){var n=u.update(t).finalize(o);u.reset();var k=n.words;var z=k.length;var q=n;for(var s=1;s<l;s++){q=u.finalize(q);u.reset();var r=q.words;for(var p=0;p<z;p++){k[p]^=r[p]}}v.concat(n);m[0]++}v.sigBytes=x*4;return v}});f.PBKDF2=function(k,l,j){return e.create(j).compute(k,l)}}());(function(){var g=a;var d=g.lib;var h=d.Base;var f=d.WordArray;var e=g.algo;var b=e.MD5;var c=e.EvpKDF=h.extend({cfg:h.extend({keySize:128/32,hasher:b,iterations:1}),init:function(i){this.cfg=this.cfg.extend(i)},compute:function(n,i){var k=this.cfg;var o=k.hasher.create();var j=f.create();var m=j.words;var l=k.keySize;var p=k.iterations;while(m.length<l){if(q){o.update(q)}var q=o.update(n).finalize(i);o.reset();for(var r=1;r<p;r++){q=o.finalize(q);o.reset()}j.concat(q)}j.sigBytes=l*4;return j}});g.EvpKDF=function(j,k,i){return c.create(i).compute(j,k)}}());(function(){var g=a;var c=g.lib;var f=c.WordArray;var d=g.algo;var e=d.SHA256;var b=d.SHA224=e.extend({_doReset:function(){this._hash=new f.init([3238371032,914150663,812702999,4144912697,4290775857,1750603025,1694076839,3204075428])},_doFinalize:function(){var h=e._doFinalize.call(this);h.sigBytes-=4;return h}});g.SHA224=e._createHelper(b);g.HmacSHA224=e._createHmacHelper(b)}());(function(f){var e=a;var h=e.lib;var g=h.Base;var d=h.WordArray;var c=e.x64={};var i=c.Word=g.extend({init:function(k,j){this.high=k;this.low=j}});var b=c.WordArray=g.extend({init:function(k,j){k=this.words=k||[];if(j!=f){this.sigBytes=j}else{this.sigBytes=k.length*8}},toX32:function(){var m=this.words;var l=m.length;var j=[];for(var k=0;k<l;k++){var n=m[k];j.push(n.high);j.push(n.low)}return d.create(j,this.sigBytes)},clone:function(){var m=g.clone.call(this);var l=m.words=this.words.slice(0);var k=l.length;for(var j=0;j<k;j++){l[j]=l[j].clone()}return m}})}());(function(j){var g=a;var i=g.lib;var e=i.WordArray;var m=i.Hasher;var b=g.x64;var l=b.Word;var h=g.algo;var f=[];var c=[];var d=[];(function(){var q=1,p=0;for(var s=0;s<24;s++){f[q+5*p]=((s+1)*(s+2)/2)%64;var u=p%5;var v=(2*q+3*p)%5;q=u;p=v}for(var q=0;q<5;q++){for(var p=0;p<5;p++){c[q+5*p]=p+((2*q+3*p)%5)*5}}var t=1;for(var y=0;y<24;y++){var o=0;var w=0;for(var x=0;x<7;x++){if(t&1){var r=(1<<x)-1;if(r<32){w^=1<<r}else{o^=1<<(r-32)}}if(t&128){t=(t<<1)^113}else{t<<=1}}d[y]=l.create(o,w)}}());var n=[];(function(){for(var o=0;o<25;o++){n[o]=l.create()}}());var k=h.SHA3=m.extend({cfg:m.cfg.extend({outputLength:512}),_doReset:function(){var p=this._state=[];for(var o=0;o<25;o++){p[o]=new l.init()}this.blockSize=(1600-2*this.cfg.outputLength)/32},_doProcessBlock:function(P,x){var t=this._state;var K=this.blockSize/2;for(var D=0;D<K;D++){var R=P[x+2*D];var H=P[x+2*D+1];R=((((R<<8)|(R>>>24))&16711935)|(((R<<24)|(R>>>8))&4278255360));H=((((H<<8)|(H>>>24))&16711935)|(((H<<24)|(H>>>8))&4278255360));var G=t[D];G.high^=H;G.low^=R}for(var J=0;J<24;J++){for(var u=0;u<5;u++){var w=0,L=0;for(var s=0;s<5;s++){var G=t[u+5*s];w^=G.high;L^=G.low}var C=n[u];C.high=w;C.low=L}for(var u=0;u<5;u++){var r=n[(u+4)%5];var F=n[(u+1)%5];var B=F.high;var o=F.low;var w=r.high^((B<<1)|(o>>>31));var L=r.low^((o<<1)|(B>>>31));for(var s=0;s<5;s++){var G=t[u+5*s];G.high^=w;G.low^=L}}for(var p=1;p<25;p++){var G=t[p];var A=G.high;var v=G.low;var E=f[p];if(E<32){var w=(A<<E)|(v>>>(32-E));var L=(v<<E)|(A>>>(32-E))}else{var w=(v<<(E-32))|(A>>>(64-E));var L=(A<<(E-32))|(v>>>(64-E))}var O=n[c[p]];O.high=w;O.low=L}var y=n[0];var z=t[0];y.high=z.high;y.low=z.low;for(var u=0;u<5;u++){for(var s=0;s<5;s++){var p=u+5*s;var G=t[p];var Q=n[p];var I=n[((u+1)%5)+5*s];var N=n[((u+2)%5)+5*s];G.high=Q.high^(~I.high&N.high);G.low=Q.low^(~I.low&N.low)}}var G=t[0];var q=d[J];G.high^=q.high;G.low^=q.low}},_doFinalize:function(){var p=this._data;var w=p.words;var s=this._nDataBytes*8;var t=p.sigBytes*8;var v=this.blockSize*32;w[t>>>5]|=1<<(24-t%32);w[((j.ceil((t+1)/v)*v)>>>5)-1]|=128;
//        p.sigBytes=w.length*4;this._process();var x=this._state;var z=this.cfg.outputLength/8;var q=z/8;var o=[];for(var A=0;A<q;A++){var y=x[A];var u=y.high;var r=y.low;u=((((u<<8)|(u>>>24))&16711935)|(((u<<24)|(u>>>8))&4278255360));r=((((r<<8)|(r>>>24))&16711935)|(((r<<24)|(r>>>8))&4278255360));o.push(r);o.push(u)}return new e.init(o,z)},clone:function(){var q=m.clone.call(this);var p=q._state=this._state.slice(0);for(var o=0;o<25;o++){p[o]=p[o].clone()}return q}});g.SHA3=m._createHelper(k);g.HmacSHA3=m._createHmacHelper(k)}(Math));(function(){var i=a;var j=i.lib;var b=j.Hasher;var c=i.x64;var l=c.Word;var g=c.WordArray;var f=i.algo;function d(){return l.create.apply(l,arguments)}var h=[d(1116352408,3609767458),d(1899447441,602891725),d(3049323471,3964484399),d(3921009573,2173295548),d(961987163,4081628472),d(1508970993,3053834265),d(2453635748,2937671579),d(2870763221,3664609560),d(3624381080,2734883394),d(310598401,1164996542),d(607225278,1323610764),d(1426881987,3590304994),d(1925078388,4068182383),d(2162078206,991336113),d(2614888103,633803317),d(3248222580,3479774868),d(3835390401,2666613458),d(4022224774,944711139),d(264347078,2341262773),d(604807628,2007800933),d(770255983,1495990901),d(1249150122,1856431235),d(1555081692,3175218132),d(1996064986,2198950837),d(2554220882,3999719339),d(2821834349,766784016),d(2952996808,2566594879),d(3210313671,3203337956),d(3336571891,1034457026),d(3584528711,2466948901),d(113926993,3758326383),d(338241895,168717936),d(666307205,1188179964),d(773529912,1546045734),d(1294757372,1522805485),d(1396182291,2643833823),d(1695183700,2343527390),d(1986661051,1014477480),d(2177026350,1206759142),d(2456956037,344077627),d(2730485921,1290863460),d(2820302411,3158454273),d(3259730800,3505952657),d(3345764771,106217008),d(3516065817,3606008344),d(3600352804,1432725776),d(4094571909,1467031594),d(275423344,851169720),d(430227734,3100823752),d(506948616,1363258195),d(659060556,3750685593),d(883997877,3785050280),d(958139571,3318307427),d(1322822218,3812723403),d(1537002063,2003034995),d(1747873779,3602036899),d(1955562222,1575990012),d(2024104815,1125592928),d(2227730452,2716904306),d(2361852424,442776044),d(2428436474,593698344),d(2756734187,3733110249),d(3204031479,2999351573),d(3329325298,3815920427),d(3391569614,3928383900),d(3515267271,566280711),d(3940187606,3454069534),d(4118630271,4000239992),d(116418474,1914138554),d(174292421,2731055270),d(289380356,3203993006),d(460393269,320620315),d(685471733,587496836),d(852142971,1086792851),d(1017036298,365543100),d(1126000580,2618297676),d(1288033470,3409855158),d(1501505948,4234509866),d(1607167915,987167468),d(1816402316,1246189591)];var k=[];(function(){for(var m=0;m<80;m++){k[m]=d()}}());var e=f.SHA512=b.extend({_doReset:function(){this._hash=new g.init([new l.init(1779033703,4089235720),new l.init(3144134277,2227873595),new l.init(1013904242,4271175723),new l.init(2773480762,1595750129),new l.init(1359893119,2917565137),new l.init(2600822924,725511199),new l.init(528734635,4215389547),new l.init(1541459225,327033209)])},_doProcessBlock:function(J,R){var K=this._hash.words;var B=K[0];var v=K[1];var r=K[2];var q=K[3];var o=K[4];var aa=K[5];var ao=K[6];var ai=K[7];var aC=B.high;var aA=B.low;var aN=v.high;var aL=v.low;var O=r.high;var z=r.low;var at=q.high;var aq=q.low;var ag=o.high;var ad=o.low;var I=aa.high;var F=aa.low;var aE=ao.high;var aD=ao.low;var aP=ai.high;var aO=ai.low;var aJ=aC;var V=aA;var C=aN;var y=aL;var aB=O;var az=z;var aM=at;var aK=aq;var N=ag;var p=ad;var ar=I;var ap=F;var ae=aE;var ab=aD;var G=aP;var D=aO;for(var aG=0;aG<80;aG++){var m=k[aG];if(aG<16){var T=m.high=J[R+aG*2]|0;var P=m.low=J[R+aG*2+1]|0}else{var L=k[aG-15];var X=L.high;var W=L.low;var ac=((X>>>1)|(W<<31))^((X>>>8)|(W<<24))^(X>>>7);var aI=((W>>>1)|(X<<31))^((W>>>8)|(X<<24))^((W>>>7)|(X<<25));var ay=k[aG-2];var U=ay.high;var Q=ay.low;var E=((U>>>19)|(Q<<13))^((U<<3)|(Q>>>29))^(U>>>6);var A=((Q>>>19)|(U<<13))^((Q<<3)|(U>>>29))^((Q>>>6)|(U<<26));var au=k[aG-7];var w=au.high;var s=au.low;var af=k[aG-16];var u=af.high;var ax=af.low;var P=aI+s;var T=ac+w+((P>>>0)<(aI>>>0)?1:0);var P=P+A;var T=T+E+((P>>>0)<(A>>>0)?1:0);var P=P+ax;var T=T+u+((P>>>0)<(ax>>>0)?1:0);m.high=T;m.low=P}var aH=(N&ar)^(~N&ae);var aF=(p&ap)^(~p&ab);var x=(aJ&C)^(aJ&aB)^(C&aB);var n=(V&y)^(V&az)^(y&az);var aw=((aJ>>>28)|(V<<4))^((aJ<<30)|(V>>>2))^((aJ<<25)|(V>>>7));var av=((V>>>28)|(aJ<<4))^((V<<30)|(aJ>>>2))^((V<<25)|(aJ>>>7));var ak=((N>>>14)|(p<<18))^((N>>>18)|(p<<14))^((N<<23)|(p>>>9));var aj=((p>>>14)|(N<<18))^((p>>>18)|(N<<14))^((p<<23)|(N>>>9));var aQ=h[aG];var t=aQ.high;var Z=aQ.low;var am=D+aj;var an=G+ak+((am>>>0)<(D>>>0)?1:0);var am=am+aF;var an=an+aH+((am>>>0)<(aF>>>0)?1:0);var am=am+Z;var an=an+t+((am>>>0)<(Z>>>0)?1:0);var am=am+P;var an=an+T+((am>>>0)<(P>>>0)?1:0);var S=av+n;var Y=aw+x+((S>>>0)<(av>>>0)?1:0);G=ae;D=ab;ae=ar;ab=ap;ar=N;ap=p;p=(aK+am)|0;N=(aM+an+((p>>>0)<(aK>>>0)?1:0))|0;aM=aB;aK=az;aB=C;az=y;C=aJ;y=V;V=(am+S)|0;aJ=(an+Y+((V>>>0)<(am>>>0)?1:0))|0}aA=B.low=(aA+V);
//        B.high=(aC+aJ+((aA>>>0)<(V>>>0)?1:0));aL=v.low=(aL+y);v.high=(aN+C+((aL>>>0)<(y>>>0)?1:0));z=r.low=(z+az);r.high=(O+aB+((z>>>0)<(az>>>0)?1:0));aq=q.low=(aq+aK);q.high=(at+aM+((aq>>>0)<(aK>>>0)?1:0));ad=o.low=(ad+p);o.high=(ag+N+((ad>>>0)<(p>>>0)?1:0));F=aa.low=(F+ap);aa.high=(I+ar+((F>>>0)<(ap>>>0)?1:0));aD=ao.low=(aD+ab);ao.high=(aE+ae+((aD>>>0)<(ab>>>0)?1:0));aO=ai.low=(aO+D);ai.high=(aP+G+((aO>>>0)<(D>>>0)?1:0))},_doFinalize:function(){var n=this._data;var p=n.words;var q=this._nDataBytes*8;var m=n.sigBytes*8;p[m>>>5]|=128<<(24-m%32);p[(((m+128)>>>10)<<5)+30]=Math.floor(q/4294967296);p[(((m+128)>>>10)<<5)+31]=q;n.sigBytes=p.length*4;this._process();var o=this._hash.toX32();return o},clone:function(){var m=b.clone.call(this);m._hash=this._hash.clone();return m},blockSize:1024/32});i.SHA512=b._createHelper(e);i.HmacSHA512=b._createHmacHelper(e)}());(function(){var g=a;var h=g.x64;var e=h.Word;var f=h.WordArray;var d=g.algo;var b=d.SHA512;var c=d.SHA384=b.extend({_doReset:function(){this._hash=new f.init([new e.init(3418070365,3238371032),new e.init(1654270250,914150663),new e.init(2438529370,812702999),new e.init(355462360,4144912697),new e.init(1731405415,4290775857),new e.init(2394180231,1750603025),new e.init(3675008525,1694076839),new e.init(1203062813,3204075428)])},_doFinalize:function(){var i=b._doFinalize.call(this);i.sigBytes-=16;return i}});g.SHA384=b._createHelper(c);g.HmacSHA384=b._createHmacHelper(c)}());a.lib.Cipher||(function(e){var n=a;var y=n.lib;var j=y.Base;var v=y.WordArray;var x=y.BufferedBlockAlgorithm;var t=n.enc;var g=t.Utf8;var m=t.Base64;var c=n.algo;var i=c.EvpKDF;var k=y.Cipher=x.extend({cfg:j.extend(),createEncryptor:function(C,B){return this.create(this._ENC_XFORM_MODE,C,B)},createDecryptor:function(C,B){return this.create(this._DEC_XFORM_MODE,C,B)},init:function(D,C,B){this.cfg=this.cfg.extend(B);this._xformMode=D;this._key=C;this.reset()},reset:function(){x.reset.call(this);this._doReset()},process:function(B){this._append(B);return this._process()},finalize:function(C){if(C){this._append(C)}var B=this._doFinalize();return B},keySize:128/32,ivSize:128/32,_ENC_XFORM_MODE:1,_DEC_XFORM_MODE:2,_createHelper:(function(){function B(C){if(typeof C=="string"){return h}else{return q}}return function(C){return{encrypt:function(F,E,D){return B(E).encrypt(C,F,E,D)},decrypt:function(F,E,D){return B(E).decrypt(C,F,E,D)}}}}())});var r=y.StreamCipher=k.extend({_doFinalize:function(){var B=this._process(!!"flush");return B},blockSize:1});var u=n.mode={};var A=y.BlockCipherMode=j.extend({createEncryptor:function(B,C){return this.Encryptor.create(B,C)},createDecryptor:function(B,C){return this.Decryptor.create(B,C)},init:function(B,C){this._cipher=B;this._iv=C}});var d=u.CBC=(function(){var B=A.extend();B.Encryptor=B.extend({processBlock:function(G,F){var D=this._cipher;var E=D.blockSize;C.call(this,G,F,E);D.encryptBlock(G,F);this._prevBlock=G.slice(F,F+E)}});B.Decryptor=B.extend({processBlock:function(H,G){var D=this._cipher;var F=D.blockSize;var E=H.slice(G,G+F);D.decryptBlock(H,G);C.call(this,H,G,F);this._prevBlock=E}});function C(I,H,F){var D=this._iv;if(D){var G=D;this._iv=e}else{var G=this._prevBlock}for(var E=0;E<F;E++){I[H+E]^=G[E]}}return B}());var f=n.pad={};var b=f.Pkcs7={pad:function(G,E){var F=E*4;var I=F-G.sigBytes%F;var B=(I<<24)|(I<<16)|(I<<8)|I;var D=[];for(var C=0;C<I;C+=4){D.push(B)}var H=v.create(D,I);G.concat(H)},unpad:function(B){var C=B.words[(B.sigBytes-1)>>>2]&255;B.sigBytes-=C}};var s=y.BlockCipher=k.extend({cfg:k.cfg.extend({mode:d,padding:b}),reset:function(){k.reset.call(this);var B=this.cfg;var C=B.iv;var E=B.mode;if(this._xformMode==this._ENC_XFORM_MODE){var D=E.createEncryptor}else{var D=E.createDecryptor;this._minBufferSize=1}if(this._mode&&this._mode.__creator==D){this._mode.init(this,C&&C.words)}else{this._mode=D.call(E,this,C&&C.words);this._mode.__creator=D}},_doProcessBlock:function(C,B){this._mode.processBlock(C,B)},_doFinalize:function(){var C=this.cfg.padding;if(this._xformMode==this._ENC_XFORM_MODE){C.pad(this._data,this.blockSize);var B=this._process(!!"flush")}else{var B=this._process(!!"flush");C.unpad(B)}return B},blockSize:128/32});var p=y.CipherParams=j.extend({init:function(B){this.mixIn(B)},toString:function(B){return(B||this.formatter).stringify(this)}});var o=n.format={};var w=o.OpenSSL={stringify:function(B){var E=B.ciphertext;var C=B.salt;if(C){var D=v.create([1398893684,1701076831]).concat(C).concat(E)}else{var D=E}return D.toString(m)},parse:function(D){var C=m.parse(D);var E=C.words;if(E[0]==1398893684&&E[1]==1701076831){var B=v.create(E.slice(2,4));E.splice(0,4);C.sigBytes-=16}return p.create({ciphertext:C,salt:B})}};var q=y.SerializableCipher=j.extend({cfg:j.extend({format:w}),encrypt:function(B,G,E,C){C=this.cfg.extend(C);var D=B.createEncryptor(E,C);var H=D.finalize(G);var F=D.cfg;return p.create({ciphertext:H,key:E,iv:F.iv,algorithm:B,mode:F.mode,padding:F.padding,blockSize:B.blockSize,formatter:C.format})},decrypt:function(B,F,D,C){C=this.cfg.extend(C);
//        F=this._parse(F,C.format);var E=B.createDecryptor(D,C).finalize(F.ciphertext);return E},_parse:function(B,C){if(typeof B=="string"){return C.parse(B,this)}else{return B}}});var l=n.kdf={};var z=l.OpenSSL={execute:function(D,G,B,F){if(!F){F=v.random(64/8)}var E=i.create({keySize:G+B}).compute(D,F);var C=v.create(E.words.slice(G),B*4);E.sigBytes=G*4;return p.create({key:E,iv:C,salt:F})}};var h=y.PasswordBasedCipher=q.extend({cfg:q.cfg.extend({kdf:z}),encrypt:function(B,E,D,C){C=this.cfg.extend(C);var G=C.kdf.execute(D,B.keySize,B.ivSize);C.iv=G.iv;var F=q.encrypt.call(this,B,E,G.key,C);F.mixIn(G);return F},decrypt:function(B,F,D,C){C=this.cfg.extend(C);F=this._parse(F,C.format);var G=C.kdf.execute(D,B.keySize,B.ivSize,F.salt);C.iv=G.iv;var E=q.decrypt.call(this,B,F,G.key,C);return E}})}());a.mode.CFB=(function(){var c=a.lib.BlockCipherMode.extend();c.Encryptor=c.extend({processBlock:function(g,f){var d=this._cipher;var e=d.blockSize;b.call(this,g,f,e,d);this._prevBlock=g.slice(f,f+e)}});c.Decryptor=c.extend({processBlock:function(h,g){var d=this._cipher;var f=d.blockSize;var e=h.slice(g,g+f);b.call(this,h,g,f,d);this._prevBlock=e}});function b(k,f,d,g){var h=this._iv;if(h){var e=h.slice(0);this._iv=undefined}else{var e=this._prevBlock}g.encryptBlock(e,0);for(var j=0;j<d;j++){k[f+j]^=e[j]}}return c}());a.mode.ECB=(function(){var b=a.lib.BlockCipherMode.extend();b.Encryptor=b.extend({processBlock:function(d,c){this._cipher.encryptBlock(d,c)}});b.Decryptor=b.extend({processBlock:function(d,c){this._cipher.decryptBlock(d,c)}});return b}());a.pad.AnsiX923={pad:function(e,c){var g=e.sigBytes;var d=c*4;var f=d-g%d;var b=g+f-1;e.clamp();e.words[b>>>2]|=f<<(24-(b%4)*8);e.sigBytes+=f},unpad:function(b){var c=b.words[(b.sigBytes-1)>>>2]&255;b.sigBytes-=c}};a.pad.Iso10126={pad:function(d,b){var c=b*4;var e=c-d.sigBytes%c;d.concat(a.lib.WordArray.random(e-1)).concat(a.lib.WordArray.create([e<<24],1))},unpad:function(b){var c=b.words[(b.sigBytes-1)>>>2]&255;b.sigBytes-=c}};a.pad.Iso97971={pad:function(c,b){c.concat(a.lib.WordArray.create([2147483648],1));a.pad.ZeroPadding.pad(c,b)},unpad:function(b){a.pad.ZeroPadding.unpad(b);b.sigBytes--}};a.mode.OFB=(function(){var c=a.lib.BlockCipherMode.extend();var b=c.Encryptor=c.extend({processBlock:function(k,f){var g=this._cipher;var d=g.blockSize;var h=this._iv;var e=this._keystream;if(h){e=this._keystream=h.slice(0);this._iv=undefined}g.encryptBlock(e,0);for(var j=0;j<d;j++){k[f+j]^=e[j]}}});c.Decryptor=b;return c}());a.pad.NoPadding={pad:function(){},unpad:function(){}};(function(e){var d=a;var h=d.lib;var g=h.CipherParams;var b=d.enc;var c=b.Hex;var f=d.format;var i=f.Hex={stringify:function(j){return j.ciphertext.toString(c)},parse:function(j){var k=c.parse(j);return g.create({ciphertext:k})}}}());(function(){var o=a;var p=o.lib;var j=p.BlockCipher;var l=o.algo;var d=[];var m=[];var c=[];var q=[];var n=[];var k=[];var i=[];var h=[];var g=[];var f=[];(function(){var s=[];for(var r=0;r<256;r++){if(r<128){s[r]=r<<1}else{s[r]=(r<<1)^283}}var v=0;var t=0;for(var r=0;r<256;r++){var u=t^(t<<1)^(t<<2)^(t<<3)^(t<<4);u=(u>>>8)^(u&255)^99;d[v]=u;m[u]=v;var z=s[v];var y=s[z];var w=s[y];var x=(s[u]*257)^(u*16843008);c[v]=(x<<24)|(x>>>8);q[v]=(x<<16)|(x>>>16);n[v]=(x<<8)|(x>>>24);k[v]=x;var x=(w*16843009)^(y*65537)^(z*257)^(v*16843008);i[u]=(x<<24)|(x>>>8);h[u]=(x<<16)|(x>>>16);g[u]=(x<<8)|(x>>>24);f[u]=x;if(!v){v=t=1}else{v=z^s[s[s[w^z]]];t^=s[s[t]]}}}());var b=[0,1,2,4,8,16,32,64,128,27,54];var e=l.AES=j.extend({_doReset:function(){if(this._nRounds&&this._keyPriorReset===this._key){return}var y=this._keyPriorReset=this._key;var r=y.words;var x=y.sigBytes/4;var w=this._nRounds=x+6;var A=(w+1)*4;var s=this._keySchedule=[];for(var v=0;v<A;v++){if(v<x){s[v]=r[v]}else{var z=s[v-1];if(!(v%x)){z=(z<<8)|(z>>>24);z=(d[z>>>24]<<24)|(d[(z>>>16)&255]<<16)|(d[(z>>>8)&255]<<8)|d[z&255];z^=b[(v/x)|0]<<24}else{if(x>6&&v%x==4){z=(d[z>>>24]<<24)|(d[(z>>>16)&255]<<16)|(d[(z>>>8)&255]<<8)|d[z&255]}}s[v]=s[v-x]^z}}var t=this._invKeySchedule=[];for(var u=0;u<A;u++){var v=A-u;if(u%4){var z=s[v]}else{var z=s[v-4]}if(u<4||v<=4){t[u]=z}else{t[u]=i[d[z>>>24]]^h[d[(z>>>16)&255]]^g[d[(z>>>8)&255]]^f[d[z&255]]}}},encryptBlock:function(s,r){this._doCryptBlock(s,r,this._keySchedule,c,q,n,k,d)},decryptBlock:function(t,s){var r=t[s+1];t[s+1]=t[s+3];t[s+3]=r;this._doCryptBlock(t,s,this._invKeySchedule,i,h,g,f,m);var r=t[s+1];t[s+1]=t[s+3];t[s+3]=r},_doCryptBlock:function(r,J,G,D,z,w,t,E){var A=this._nRounds;var H=r[J]^G[0];var F=r[J+1]^G[1];var B=r[J+2]^G[2];var x=r[J+3]^G[3];var C=4;for(var I=1;I<A;I++){var y=D[H>>>24]^z[(F>>>16)&255]^w[(B>>>8)&255]^t[x&255]^G[C++];var v=D[F>>>24]^z[(B>>>16)&255]^w[(x>>>8)&255]^t[H&255]^G[C++];var u=D[B>>>24]^z[(x>>>16)&255]^w[(H>>>8)&255]^t[F&255]^G[C++];var s=D[x>>>24]^z[(H>>>16)&255]^w[(F>>>8)&255]^t[B&255]^G[C++];H=y;F=v;B=u;x=s}var y=((E[H>>>24]<<24)|(E[(F>>>16)&255]<<16)|(E[(B>>>8)&255]<<8)|E[x&255])^G[C++];var v=((E[F>>>24]<<24)|(E[(B>>>16)&255]<<16)|(E[(x>>>8)&255]<<8)|E[H&255])^G[C++];
//        var u=((E[B>>>24]<<24)|(E[(x>>>16)&255]<<16)|(E[(H>>>8)&255]<<8)|E[F&255])^G[C++];var s=((E[x>>>24]<<24)|(E[(H>>>16)&255]<<16)|(E[(F>>>8)&255]<<8)|E[B&255])^G[C++];r[J]=y;r[J+1]=v;r[J+2]=u;r[J+3]=s},keySize:256/32});o.AES=j._createHelper(e)}());(function(){var d=a;var f=d.lib;var m=f.WordArray;var e=f.BlockCipher;var n=d.algo;var j=[57,49,41,33,25,17,9,1,58,50,42,34,26,18,10,2,59,51,43,35,27,19,11,3,60,52,44,36,63,55,47,39,31,23,15,7,62,54,46,38,30,22,14,6,61,53,45,37,29,21,13,5,28,20,12,4];var c=[14,17,11,24,1,5,3,28,15,6,21,10,23,19,12,4,26,8,16,7,27,20,13,2,41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32];var b=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28];var o=[{0:8421888,268435456:32768,536870912:8421378,805306368:2,1073741824:512,1342177280:8421890,1610612736:8389122,1879048192:8388608,2147483648:514,2415919104:8389120,2684354560:33280,2952790016:8421376,3221225472:32770,3489660928:8388610,3758096384:0,4026531840:33282,134217728:0,402653184:8421890,671088640:33282,939524096:32768,1207959552:8421888,1476395008:512,1744830464:8421378,2013265920:2,2281701376:8389120,2550136832:33280,2818572288:8421376,3087007744:8389122,3355443200:8388610,3623878656:32770,3892314112:514,4160749568:8388608,1:32768,268435457:2,536870913:8421888,805306369:8388608,1073741825:8421378,1342177281:33280,1610612737:512,1879048193:8389122,2147483649:8421890,2415919105:8421376,2684354561:8388610,2952790017:33282,3221225473:514,3489660929:8389120,3758096385:32770,4026531841:0,134217729:8421890,402653185:8421376,671088641:8388608,939524097:512,1207959553:32768,1476395009:8388610,1744830465:2,2013265921:33282,2281701377:32770,2550136833:8389122,2818572289:514,3087007745:8421888,3355443201:8389120,3623878657:0,3892314113:33280,4160749569:8421378},{0:1074282512,16777216:16384,33554432:524288,50331648:1074266128,67108864:1073741840,83886080:1074282496,100663296:1073758208,117440512:16,134217728:540672,150994944:1073758224,167772160:1073741824,184549376:540688,201326592:524304,218103808:0,234881024:16400,251658240:1074266112,8388608:1073758208,25165824:540688,41943040:16,58720256:1073758224,75497472:1074282512,92274688:1073741824,109051904:524288,125829120:1074266128,142606336:524304,159383552:0,176160768:16384,192937984:1074266112,209715200:1073741840,226492416:540672,243269632:1074282496,260046848:16400,268435456:0,285212672:1074266128,301989888:1073758224,318767104:1074282496,335544320:1074266112,352321536:16,369098752:540688,385875968:16384,402653184:16400,419430400:524288,436207616:524304,452984832:1073741840,469762048:540672,486539264:1073758208,503316480:1073741824,520093696:1074282512,276824064:540688,293601280:524288,310378496:1074266112,327155712:16384,343932928:1073758208,360710144:1074282512,377487360:16,394264576:1073741824,411041792:1074282496,427819008:1073741840,444596224:1073758224,461373440:524304,478150656:0,494927872:16400,511705088:1074266128,528482304:540672},{0:260,1048576:0,2097152:67109120,3145728:65796,4194304:65540,5242880:67108868,6291456:67174660,7340032:67174400,8388608:67108864,9437184:67174656,10485760:65792,11534336:67174404,12582912:67109124,13631488:65536,14680064:4,15728640:256,524288:67174656,1572864:67174404,2621440:0,3670016:67109120,4718592:67108868,5767168:65536,6815744:65540,7864320:260,8912896:4,9961472:256,11010048:67174400,12058624:65796,13107200:65792,14155776:67109124,15204352:67174660,16252928:67108864,16777216:67174656,17825792:65540,18874368:65536,19922944:67109120,20971520:256,22020096:67174660,23068672:67108868,24117248:0,25165824:67109124,26214400:67108864,27262976:4,28311552:65792,29360128:67174400,30408704:260,31457280:65796,32505856:67174404,17301504:67108864,18350080:260,19398656:67174656,20447232:0,21495808:65540,22544384:67109120,23592960:256,24641536:67174404,25690112:65536,26738688:67174660,27787264:65796,28835840:67108868,29884416:67109124,30932992:67174400,31981568:4,33030144:65792},{0:2151682048,65536:2147487808,131072:4198464,196608:2151677952,262144:0,327680:4198400,393216:2147483712,458752:4194368,524288:2147483648,589824:4194304,655360:64,720896:2147487744,786432:2151678016,851968:4160,917504:4096,983040:2151682112,32768:2147487808,98304:64,163840:2151678016,229376:2147487744,294912:4198400,360448:2151682112,425984:0,491520:2151677952,557056:4096,622592:2151682048,688128:4194304,753664:4160,819200:2147483648,884736:4194368,950272:4198464,1015808:2147483712,1048576:4194368,1114112:4198400,1179648:2147483712,1245184:0,1310720:4160,1376256:2151678016,1441792:2151682048,1507328:2147487808,1572864:2151682112,1638400:2147483648,1703936:2151677952,1769472:4198464,1835008:2147487744,1900544:4194304,1966080:64,2031616:4096,1081344:2151677952,1146880:2151682112,1212416:0,1277952:4198400,1343488:4194368,1409024:2147483648,1474560:2147487808,1540096:64,1605632:2147483712,1671168:4096,1736704:2147487744,1802240:2151678016,1867776:4160,1933312:2151682048,1998848:4194304,2064384:4198464},{0:128,4096:17039360,8192:262144,12288:536870912,16384:537133184,20480:16777344,24576:553648256,28672:262272,32768:16777216,36864:537133056,40960:536871040,45056:553910400,49152:553910272,53248:0,57344:17039488,61440:553648128,2048:17039488,6144:553648256,10240:128,14336:17039360,18432:262144,22528:537133184,26624:553910272,30720:536870912,34816:537133056,38912:0,43008:553910400,47104:16777344,51200:536871040,55296:553648128,59392:16777216,63488:262272,65536:262144,69632:128,73728:536870912,77824:553648256,81920:16777344,86016:553910272,90112:537133184,94208:16777216,98304:553910400,102400:553648128,106496:17039360,110592:537133056,114688:262272,118784:536871040,122880:0,126976:17039488,67584:553648256,71680:16777216,75776:17039360,79872:537133184,83968:536870912,88064:17039488,92160:128,96256:553910272,100352:262272,104448:553910400,108544:0,112640:553648128,116736:16777344,120832:262144,124928:537133056,129024:536871040},{0:268435464,256:8192,512:270532608,768:270540808,1024:268443648,1280:2097152,1536:2097160,1792:268435456,2048:0,2304:268443656,2560:2105344,2816:8,3072:270532616,3328:2105352,3584:8200,3840:270540800,128:270532608,384:270540808,640:8,896:2097152,1152:2105352,1408:268435464,1664:268443648,1920:8200,2176:2097160,2432:8192,2688:268443656,2944:270532616,3200:0,3456:270540800,3712:2105344,3968:268435456,4096:268443648,4352:270532616,4608:270540808,4864:8200,5120:2097152,5376:268435456,5632:268435464,5888:2105344,6144:2105352,6400:0,6656:8,6912:270532608,7168:8192,7424:268443656,7680:270540800,7936:2097160,4224:8,4480:2105344,4736:2097152,4992:268435464,5248:268443648,5504:8200,5760:270540808,6016:270532608,6272:270540800,6528:270532616,6784:8192,7040:2105352,7296:2097160,7552:0,7808:268435456,8064:268443656},{0:1048576,16:33555457,32:1024,48:1049601,64:34604033,80:0,96:1,112:34603009,128:33555456,144:1048577,160:33554433,176:34604032,192:34603008,208:1025,224:1049600,240:33554432,8:34603009,24:0,40:33555457,56:34604032,72:1048576,88:33554433,104:33554432,120:1025,136:1049601,152:33555456,168:34603008,184:1048577,200:1024,216:34604033,232:1,248:1049600,256:33554432,272:1048576,288:33555457,304:34603009,320:1048577,336:33555456,352:34604032,368:1049601,384:1025,400:34604033,416:1049600,432:1,448:0,464:34603008,480:33554433,496:1024,264:1049600,280:33555457,296:34603009,312:1,328:33554432,344:1048576,360:1025,376:34604032,392:33554433,408:34603008,424:0,440:34604033,456:1049601,472:1024,488:33555456,504:1048577},{0:134219808,1:131072,2:134217728,3:32,4:131104,5:134350880,6:134350848,7:2048,8:134348800,9:134219776,10:133120,11:134348832,12:2080,13:0,14:134217760,15:133152,2147483648:2048,2147483649:134350880,2147483650:134219808,2147483651:134217728,2147483652:134348800,2147483653:133120,2147483654:133152,2147483655:32,2147483656:134217760,2147483657:2080,2147483658:131104,2147483659:134350848,2147483660:0,2147483661:134348832,2147483662:134219776,2147483663:131072,16:133152,17:134350848,18:32,19:2048,20:134219776,21:134217760,22:134348832,23:131072,24:0,25:131104,26:134348800,27:134219808,28:134350880,29:133120,30:2080,31:134217728,2147483664:131072,2147483665:2048,2147483666:134348832,2147483667:133152,2147483668:32,2147483669:134348800,2147483670:134217728,2147483671:134219808,2147483672:134350880,2147483673:134217760,2147483674:134219776,2147483675:0,2147483676:133120,2147483677:2080,2147483678:131104,2147483679:134350848}];
//    var k=[4160749569,528482304,33030144,2064384,129024,8064,504,2147483679];var g=n.DES=e.extend({_doReset:function(){var u=this._key;var y=u.words;var t=[];for(var s=0;s<56;s++){var q=j[s]-1;t[s]=(y[q>>>5]>>>(31-q%32))&1}var w=this._subKeys=[];for(var p=0;p<16;p++){var r=w[p]=[];var v=b[p];for(var s=0;s<24;s++){r[(s/6)|0]|=t[((c[s]-1)+v)%28]<<(31-s%6);r[4+((s/6)|0)]|=t[28+(((c[s+24]-1)+v)%28)]<<(31-s%6)}r[0]=(r[0]<<1)|(r[0]>>>31);for(var s=1;s<7;s++){r[s]=r[s]>>>((s-1)*4+3)}r[7]=(r[7]<<5)|(r[7]>>>27)}var x=this._invSubKeys=[];for(var s=0;s<16;s++){x[s]=w[15-s]}},encryptBlock:function(q,p){this._doCryptBlock(q,p,this._subKeys)},decryptBlock:function(q,p){this._doCryptBlock(q,p,this._invSubKeys)},_doCryptBlock:function(t,p,x){this._lBlock=t[p];this._rBlock=t[p+1];h.call(this,4,252645135);h.call(this,16,65535);i.call(this,2,858993459);i.call(this,8,16711935);h.call(this,1,1431655765);for(var v=0;v<16;v++){var r=x[v];var y=this._lBlock;var w=this._rBlock;var s=0;for(var q=0;q<8;q++){s|=o[q][((w^r[q])&k[q])>>>0]}this._lBlock=w;this._rBlock=y^s}var u=this._lBlock;this._lBlock=this._rBlock;this._rBlock=u;h.call(this,1,1431655765);i.call(this,8,16711935);i.call(this,2,858993459);h.call(this,16,65535);h.call(this,4,252645135);t[p]=this._lBlock;t[p+1]=this._rBlock},keySize:64/32,ivSize:64/32,blockSize:64/32});function h(r,p){var q=((this._lBlock>>>r)^this._rBlock)&p;this._rBlock^=q;this._lBlock^=q<<r}function i(r,p){var q=((this._rBlock>>>r)^this._lBlock)&p;this._lBlock^=q;this._rBlock^=q<<r}d.DES=e._createHelper(g);var l=n.TripleDES=e.extend({_doReset:function(){var p=this._key;var q=p.words;this._des1=g.createEncryptor(m.create(q.slice(0,2)));this._des2=g.createEncryptor(m.create(q.slice(2,4)));this._des3=g.createEncryptor(m.create(q.slice(4,6)))},encryptBlock:function(q,p){this._des1.encryptBlock(q,p);this._des2.decryptBlock(q,p);this._des3.encryptBlock(q,p)},decryptBlock:function(q,p){this._des3.decryptBlock(q,p);this._des2.encryptBlock(q,p);this._des1.decryptBlock(q,p)},keySize:192/32,ivSize:64/32,blockSize:64/32});d.TripleDES=e._createHelper(l)}());(function(){var f=a;var h=f.lib;var g=h.StreamCipher;var d=f.algo;var b=d.RC4=g.extend({_doReset:function(){var m=this._key;var p=m.words;var q=m.sigBytes;var i=this._S=[];for(var k=0;k<256;k++){i[k]=k}for(var k=0,j=0;k<256;k++){var o=k%q;var l=(p[o>>>2]>>>(24-(o%4)*8))&255;j=(j+i[k]+l)%256;var n=i[k];i[k]=i[j];i[j]=n}this._i=this._j=0},_doProcessBlock:function(j,i){j[i]^=e.call(this)},keySize:256/32,ivSize:0});function e(){var i=this._S;var n=this._i;var l=this._j;var j=0;for(var k=0;k<4;k++){n=(n+1)%256;l=(l+i[n])%256;var m=i[n];i[n]=i[l];i[l]=m;j|=i[(i[n]+i[l])%256]<<(24-k*8)}this._i=n;this._j=l;return j}f.RC4=g._createHelper(b);var c=d.RC4Drop=b.extend({cfg:b.cfg.extend({drop:192}),_doReset:function(){b._doReset.call(this);for(var i=this.cfg.drop;i>0;i--){e.call(this)}}});f.RC4Drop=g._createHelper(c)}());a.mode.CTRGladman=(function(){var b=a.lib.BlockCipherMode.extend();function e(i){if(((i>>24)&255)===255){var h=(i>>16)&255;var g=(i>>8)&255;var f=i&255;if(h===255){h=0;if(g===255){g=0;if(f===255){f=0}else{++f}}else{++g}}else{++h}i=0;i+=(h<<16);i+=(g<<8);i+=f}else{i+=(1<<24)}return i}function d(f){if((f[0]=e(f[0]))===0){f[1]=e(f[1])}return f}var c=b.Encryptor=b.extend({processBlock:function(g,n){var h=this._cipher;var k=h.blockSize;var m=this._iv;var j=this._counter;if(m){j=this._counter=m.slice(0);this._iv=undefined}d(j);var l=j.slice(0);h.encryptBlock(l,0);for(var f=0;f<k;f++){g[n+f]^=l[f]}}});b.Decryptor=c;return b}());(function(){var b=a;var c=b.lib;var d=c.StreamCipher;var g=b.algo;var e=[];var f=[];var h=[];var i=g.Rabbit=d.extend({_doReset:function(){var u=this._key.words;var p=this.cfg.iv;for(var r=0;r<4;r++){u[r]=(((u[r]<<8)|(u[r]>>>24))&16711935)|(((u[r]<<24)|(u[r]>>>8))&4278255360)}var l=this._X=[u[0],(u[3]<<16)|(u[2]>>>16),u[1],(u[0]<<16)|(u[3]>>>16),u[2],(u[1]<<16)|(u[0]>>>16),u[3],(u[2]<<16)|(u[1]>>>16)];var k=this._C=[(u[2]<<16)|(u[2]>>>16),(u[0]&4294901760)|(u[1]&65535),(u[3]<<16)|(u[3]>>>16),(u[1]&4294901760)|(u[2]&65535),(u[0]<<16)|(u[0]>>>16),(u[2]&4294901760)|(u[3]&65535),(u[1]<<16)|(u[1]>>>16),(u[3]&4294901760)|(u[0]&65535)];this._b=0;for(var r=0;r<4;r++){j.call(this)}for(var r=0;r<8;r++){k[r]^=l[(r+4)&7]}if(p){var v=p.words;var t=v[0];var s=v[1];var q=(((t<<8)|(t>>>24))&16711935)|(((t<<24)|(t>>>8))&4278255360);var n=(((s<<8)|(s>>>24))&16711935)|(((s<<24)|(s>>>8))&4278255360);var o=(q>>>16)|(n&4294901760);var m=(n<<16)|(q&65535);k[0]^=q;k[1]^=o;k[2]^=n;k[3]^=m;k[4]^=q;k[5]^=o;k[6]^=n;k[7]^=m;for(var r=0;r<4;r++){j.call(this)}}},_doProcessBlock:function(k,m){var n=this._X;j.call(this);e[0]=n[0]^(n[5]>>>16)^(n[3]<<16);e[1]=n[2]^(n[7]>>>16)^(n[5]<<16);e[2]=n[4]^(n[1]>>>16)^(n[7]<<16);e[3]=n[6]^(n[3]>>>16)^(n[1]<<16);for(var l=0;l<4;l++){e[l]=(((e[l]<<8)|(e[l]>>>24))&16711935)|(((e[l]<<24)|(e[l]>>>8))&4278255360);k[m+l]^=e[l]}},blockSize:128/32,ivSize:64/32});function j(){var o=this._X;var n=this._C;for(var q=0;q<8;q++){f[q]=n[q]}n[0]=(n[0]+1295307597+this._b)|0;
//    n[1]=(n[1]+3545052371+((n[0]>>>0)<(f[0]>>>0)?1:0))|0;n[2]=(n[2]+886263092+((n[1]>>>0)<(f[1]>>>0)?1:0))|0;n[3]=(n[3]+1295307597+((n[2]>>>0)<(f[2]>>>0)?1:0))|0;n[4]=(n[4]+3545052371+((n[3]>>>0)<(f[3]>>>0)?1:0))|0;n[5]=(n[5]+886263092+((n[4]>>>0)<(f[4]>>>0)?1:0))|0;n[6]=(n[6]+1295307597+((n[5]>>>0)<(f[5]>>>0)?1:0))|0;n[7]=(n[7]+3545052371+((n[6]>>>0)<(f[6]>>>0)?1:0))|0;this._b=(n[7]>>>0)<(f[7]>>>0)?1:0;for(var q=0;q<8;q++){var k=o[q]+n[q];var m=k&65535;var r=k>>>16;var p=((((m*m)>>>17)+m*r)>>>15)+r*r;var l=(((k&4294901760)*k)|0)+(((k&65535)*k)|0);h[q]=p^l}o[0]=(h[0]+((h[7]<<16)|(h[7]>>>16))+((h[6]<<16)|(h[6]>>>16)))|0;o[1]=(h[1]+((h[0]<<8)|(h[0]>>>24))+h[7])|0;o[2]=(h[2]+((h[1]<<16)|(h[1]>>>16))+((h[0]<<16)|(h[0]>>>16)))|0;o[3]=(h[3]+((h[2]<<8)|(h[2]>>>24))+h[1])|0;o[4]=(h[4]+((h[3]<<16)|(h[3]>>>16))+((h[2]<<16)|(h[2]>>>16)))|0;o[5]=(h[5]+((h[4]<<8)|(h[4]>>>24))+h[3])|0;o[6]=(h[6]+((h[5]<<16)|(h[5]>>>16))+((h[4]<<16)|(h[4]>>>16)))|0;o[7]=(h[7]+((h[6]<<8)|(h[6]>>>24))+h[5])|0}b.Rabbit=d._createHelper(i)}());a.mode.CTR=(function(){var c=a.lib.BlockCipherMode.extend();var b=c.Encryptor=c.extend({processBlock:function(l,e){var f=this._cipher;var k=f.blockSize;var h=this._iv;var g=this._counter;if(h){g=this._counter=h.slice(0);this._iv=undefined}var d=g.slice(0);f.encryptBlock(d,0);g[k-1]=(g[k-1]+1)|0;for(var j=0;j<k;j++){l[e+j]^=d[j]}}});c.Decryptor=b;return c}());(function(){var b=a;var c=b.lib;var d=c.StreamCipher;var g=b.algo;var e=[];var f=[];var h=[];var i=g.RabbitLegacy=d.extend({_doReset:function(){var u=this._key.words;var p=this.cfg.iv;var l=this._X=[u[0],(u[3]<<16)|(u[2]>>>16),u[1],(u[0]<<16)|(u[3]>>>16),u[2],(u[1]<<16)|(u[0]>>>16),u[3],(u[2]<<16)|(u[1]>>>16)];var k=this._C=[(u[2]<<16)|(u[2]>>>16),(u[0]&4294901760)|(u[1]&65535),(u[3]<<16)|(u[3]>>>16),(u[1]&4294901760)|(u[2]&65535),(u[0]<<16)|(u[0]>>>16),(u[2]&4294901760)|(u[3]&65535),(u[1]<<16)|(u[1]>>>16),(u[3]&4294901760)|(u[0]&65535)];this._b=0;for(var r=0;r<4;r++){j.call(this)}for(var r=0;r<8;r++){k[r]^=l[(r+4)&7]}if(p){var v=p.words;var t=v[0];var s=v[1];var q=(((t<<8)|(t>>>24))&16711935)|(((t<<24)|(t>>>8))&4278255360);var n=(((s<<8)|(s>>>24))&16711935)|(((s<<24)|(s>>>8))&4278255360);var o=(q>>>16)|(n&4294901760);var m=(n<<16)|(q&65535);k[0]^=q;k[1]^=o;k[2]^=n;k[3]^=m;k[4]^=q;k[5]^=o;k[6]^=n;k[7]^=m;for(var r=0;r<4;r++){j.call(this)}}},_doProcessBlock:function(k,m){var n=this._X;j.call(this);e[0]=n[0]^(n[5]>>>16)^(n[3]<<16);e[1]=n[2]^(n[7]>>>16)^(n[5]<<16);e[2]=n[4]^(n[1]>>>16)^(n[7]<<16);e[3]=n[6]^(n[3]>>>16)^(n[1]<<16);for(var l=0;l<4;l++){e[l]=(((e[l]<<8)|(e[l]>>>24))&16711935)|(((e[l]<<24)|(e[l]>>>8))&4278255360);k[m+l]^=e[l]}},blockSize:128/32,ivSize:64/32});function j(){var o=this._X;var n=this._C;for(var q=0;q<8;q++){f[q]=n[q]}n[0]=(n[0]+1295307597+this._b)|0;n[1]=(n[1]+3545052371+((n[0]>>>0)<(f[0]>>>0)?1:0))|0;n[2]=(n[2]+886263092+((n[1]>>>0)<(f[1]>>>0)?1:0))|0;n[3]=(n[3]+1295307597+((n[2]>>>0)<(f[2]>>>0)?1:0))|0;n[4]=(n[4]+3545052371+((n[3]>>>0)<(f[3]>>>0)?1:0))|0;n[5]=(n[5]+886263092+((n[4]>>>0)<(f[4]>>>0)?1:0))|0;n[6]=(n[6]+1295307597+((n[5]>>>0)<(f[5]>>>0)?1:0))|0;n[7]=(n[7]+3545052371+((n[6]>>>0)<(f[6]>>>0)?1:0))|0;this._b=(n[7]>>>0)<(f[7]>>>0)?1:0;for(var q=0;q<8;q++){var k=o[q]+n[q];var m=k&65535;var r=k>>>16;var p=((((m*m)>>>17)+m*r)>>>15)+r*r;var l=(((k&4294901760)*k)|0)+(((k&65535)*k)|0);h[q]=p^l}o[0]=(h[0]+((h[7]<<16)|(h[7]>>>16))+((h[6]<<16)|(h[6]>>>16)))|0;o[1]=(h[1]+((h[0]<<8)|(h[0]>>>24))+h[7])|0;o[2]=(h[2]+((h[1]<<16)|(h[1]>>>16))+((h[0]<<16)|(h[0]>>>16)))|0;o[3]=(h[3]+((h[2]<<8)|(h[2]>>>24))+h[1])|0;o[4]=(h[4]+((h[3]<<16)|(h[3]>>>16))+((h[2]<<16)|(h[2]>>>16)))|0;o[5]=(h[5]+((h[4]<<8)|(h[4]>>>24))+h[3])|0;o[6]=(h[6]+((h[5]<<16)|(h[5]>>>16))+((h[4]<<16)|(h[4]>>>16)))|0;o[7]=(h[7]+((h[6]<<8)|(h[6]>>>24))+h[5])|0}b.RabbitLegacy=d._createHelper(i)}());a.pad.ZeroPadding={pad:function(d,b){var c=b*4;d.clamp();d.sigBytes+=c-((d.sigBytes%c)||c)},unpad:function(c){var d=c.words;var b=c.sigBytes-1;while(!((d[b>>>2]>>>(24-(b%4)*8))&255)){b--}c.sigBytes=b+1}};return a}));
